// oCourse.h: interface for the oCourse class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OCOURSE_H__936E61C9_CDAC_490D_A475_E58190A2910C__INCLUDED_)
#define AFX_OCOURSE_H__936E61C9_CDAC_490D_A475_E58190A2910C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/************************************************************************
    MeOS - Orienteering Software
    Copyright (C) 2009 Melin Software HB
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Melin Software HB - software@melin.nu - www.melin.nu
    Stigbergsvgen 7, SE-75242 UPPSALA, Sweden
    
************************************************************************/

#include "oControl.h"

class oEvent;
class oCourse;
typedef oCourse * pCourse;

class gdioutput;
class oDataInterface;

struct SICard;

class oCourse : public oBase
{
protected:
	pControl Controls[64];
	int nControls;
	string Name;
	int Length;
	BYTE oData[32];

  int tMapsRemaining;
public:
  bool operator<(const oCourse &b) const {return Name<b.Name;}
	

  void setNumberMaps(int nm);
  int getNumberMaps() const;

  string getInfo() const;

	oDataInterface getDI();
	oDataConstInterface getDCI() const;

	oControl *getControl(int index);

	int distance(const SICard &card);

	bool fillCourse(gdioutput &gdi, const string &name);

	void importControls(const string &cstring);
	pControl addControl(int Id);
	void Set(const xmlobject *xo);

  void getControls(list<pControl> &pc);
	string getControls() const;
	string getControlsUI() const;
	string getCourseReadable() const;

	const string &getName() const {return Name;}
	int getLength() const {return Length;}
  string getLengthS() const;

	void setName(const string &n);
	void setLength(int l);

  string getStart() const;
  void setStart(const string &start, bool sync);

	bool Write(xmlparser &xml);

  oCourse::oCourse(oEvent *poe, int id);
	oCourse(oEvent *poe);
	virtual ~oCourse();

	friend class oEvent;
	friend class oClass;
	friend class oRunner;
	friend class MeosSQL;

};

#endif // !defined(AFX_OCOURSE_H__936E61C9_CDAC_490D_A475_E58190A2910C__INCLUDED_)
