/************************************************************************
    MeOS - Orienteering Software
    Copyright (C) 2009 Melin Software HB
    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Melin Software HB - software@melin.nu - www.melin.nu
    Stigbergsvgen 7, SE-75242 UPPSALA, Sweden
    
************************************************************************/

#include "stdafx.h"
#include "oFreePunch.h"

oFreePunch::oFreePunch(oEvent *poe): oPunch(poe)
{
}

oFreePunch::oFreePunch(oEvent *poe, int id): oPunch(poe)
{
  Id=id;
}

oFreePunch::~oFreePunch(void)
{
}

bool oFreePunch::Write(xmlparser &xml)
{
	if(Removed) return true;

	xml.StartTag("Punch");
	xml.Write("CardNo", CardNo);
	xml.Write("Time", Time);
	xml.Write("Type", Type);
	xml.Write("Id", Id);
	xml.Write("Updated", Modified.GetStamp());
	xml.EndTag();

	return true;
}

void oFreePunch::Set(const xmlobject *xo)
{
	const xmlList *xl=xo->GetObjects();

	if(xl){
		xmlList::const_iterator it;

		for(it=xl->begin(); it != xl->end(); ++it){
			if(it->Is("CardNo")){
				CardNo=atoi(it->Get().c_str());			
			}
			if(it->Is("Type")){
				Type=atoi(it->Get().c_str());			
			}			
			if(it->Is("Time")){
				Time=atoi(it->Get().c_str());			
			}			
			else if(it->Is("Id")){
				Id=atoi(it->Get().c_str());			
			}
			else if(it->Is("Updated")){
				Modified.SetStamp(it->Get());
			}
		}
	}
}


void oFreePunch::setData(int card, int time, int type)
{
	CardNo=card;
	Time=time;
	Type=type;
	updateChanged();	
}